package budrys.bca;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Messenger;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class BCAActivity extends ServiceAbstractActivity  {
	public static Activity activity;
	
	EditText editMyIP, editRemoteIP, editMyPort, editRemotePort;
    Button btnStart, btnStop, btnFriends, btnSocial, btnDht, btnProfile, btnBoot;
    TextView textStatus, textIntValue, textMyID, textSuccessor, textPredecessor;
    Spinner editMyIPCombo;
    
    private Intent service;
    
    class IncomingHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {
        	Bundle args = msg.getData();
        	String arg1 = args.getString("arg1");
        	String arg2 = args.getString("arg2");
//        	int arg3 = msg.arg1;
//        	int arg4 = msg.arg2;
            switch (msg.what) {
            case BCAService.MSG_REGISTER_CLIENT:
            	// time to start dht
            	textStatus.setText("2/3 Registered.");
                //sendCommandToService(DHTService.MSG_START_DHT_SERVICE, editMyIP.getText().toString(), editRemoteIP.getText().toString(), 15042, 10105);
            	sendCommandToService(BCAService.MSG_START_DHT_SERVICE, editMyIP.getText().toString(), editRemoteIP.getText().toString(), Integer.valueOf(editMyPort.getText().toString()), Integer.valueOf(editRemotePort.getText().toString()));
//            	sendCommandToService(DHTService.MSG_START_DHT_SERVICE, editMyIPCombo.getSelectedItem().toString(), editRemoteIP.getText().toString(), Integer.valueOf(editMyPort.getText().toString()), Integer.valueOf(editRemotePort.getText().toString()));
            	break;
            case BCAService.MSG_SET_INT_VALUE:
            	int s = msg.arg1;
                textIntValue.setText("Service runing for: " + String.format("%d:%02d:%02d", s/3600, (s%3600)/60, (s%60)));
                break;
            case BCAService.MSG_START_DHT_SERVICE:
            	textMyID.setText("My ID: "+arg1);
            	break;
            case BCAService.MSG_REPORT_NEIGHBOURS:
            	textSuccessor.setText("Successor: "+arg1);
            	textPredecessor.setText("Predecessor: "+arg2);
            	break;
            case BCAService.MSG_DHT_ALREADY_RUNING:
            	textMyID.setText("My ID: "+arg1);
            	easyToast("DHT is already runing. New one not created.");
            	break;
            case BCAService.MSG_START_DHT_SERVICE_STATUS:
            	if (arg1.equals("OK")){
            		textStatus.setText("3/3 Connected.");
            	} else {
            		textStatus.setText("3/3 Failed to connect.");
            	}
            	break;
            case BCAService.MSG_SOCIAL_PROFILE_PUBLISHED:
            	textStatus.append("[PUB]");
            	easyToast("Profile published "+arg1);
            	break;
            	
            default:
                super.handleMessage(msg);
            }
        }
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        btnStart = (Button)findViewById(R.id.btnStart);
        btnStop = (Button)findViewById(R.id.btnStop);
        btnSocial = (Button)findViewById(R.id.btnSocial);
        btnProfile = (Button)findViewById(R.id.btnProfile);
        btnFriends = (Button)findViewById(R.id.btnFriends);
        btnBoot = (Button)findViewById(R.id.btnBoot);
        btnDht = (Button)findViewById(R.id.btnDht);
        
        textStatus = (TextView)findViewById(R.id.textStatus);
        textIntValue = (TextView)findViewById(R.id.textIntValue);
        textMyID = (TextView)findViewById(R.id.textMyID);
        textSuccessor = (TextView)findViewById(R.id.textSuccessor);
        textPredecessor = (TextView)findViewById(R.id.textPredecessor);
        
        editMyIP = (EditText)findViewById(R.id.editMyIP);
        editRemoteIP = (EditText)findViewById(R.id.editRemoteIP);
        editMyPort = (EditText)findViewById(R.id.editMyPort);
        editRemotePort = (EditText)findViewById(R.id.editRemotePort);
        
        editMyIPCombo = (Spinner)findViewById(R.id.editMyIPCombo);
        
        // Required by ServiceActivity
        mConnection = new ServiceConnection() {
            public void onServiceConnected(ComponentName className, IBinder service) {
                mService = new Messenger(service);
                textStatus.setText("1/3 Attached.");
                try {
                    Message msg = Message.obtain(null, BCAService.MSG_REGISTER_CLIENT);
                    msg.replyTo = mMessenger;
                    mService.send(msg);
                } catch (RemoteException e) {
                    // In this case the service has crashed before we could even do anything with it
                }
            }

            public void onServiceDisconnected(ComponentName className) {
                // This is called when the connection with the service has been unexpectedly disconnected - process crashed.
                mService = null;
                textStatus.setText("Disconnected.");
            }
        };
        mMessenger = new Messenger(new IncomingHandler());
        
        BCAActivity.activity = this;
        
        // POPULATE MY IP LIST
        List<String> list = new ArrayList<String>();
		  try {
		      for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
		          NetworkInterface intf = en.nextElement();
		          for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
		              InetAddress inetAddress = enumIpAddr.nextElement();
		              if (!inetAddress.isLoopbackAddress()) {
//		              	result += intf.getName()+":: "+inetAddress.getHostAddress().toString()+"\n";
		            	if (inetAddress.getHostAddress().length() <= 16){
			            	if (intf.getName().length()>=6){
			            		if (intf.getName().substring(0, 5).equals("rmnet")){
				            		list.add(inetAddress.getHostAddress().toString());		            		
				            	}
			            	} else if (intf.getName().length()>=5){
			            		if (intf.getName().substring(0, 4).equals("wlan")){
				            		list.add(inetAddress.getHostAddress().toString());		            		
				            	}	
			            	} else if (intf.getName().length()>=4){
			            		if (intf.getName().substring(0, 3).equals("eth")){
				            		list.add(inetAddress.getHostAddress().toString());		            		
				            	}	
			            	}
		            	}
		            	
		              }
		          }
		      }
		  } catch (SocketException ex) {
		      Log.e("Log", ex.toString());
		  }
    	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this,
    		android.R.layout.simple_spinner_item, list);
    	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    	editMyIPCombo.setAdapter(dataAdapter);
    	editMyIPCombo.setOnItemSelectedListener(new OnItemSelectedListener() {
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int pos, long id) {
				editMyIP.setText(arg0.getItemAtPosition(pos).toString());
			}
			public void onNothingSelected(AdapterView<?> arg0) {
				editMyIP.setText("no interface");
			}
		});
        
        btnStart.setOnClickListener(btnStartListener);
        btnStop.setOnClickListener(btnStopListener);
        
        btnSocial.setOnClickListener(btnSocialListener);
        
        btnProfile.setOnClickListener(btnProfileListener);
        btnFriends.setOnClickListener(btnFriendsListener);
        
        btnBoot.setOnClickListener(btnBootListener);
        btnDht.setOnClickListener(btnDhtListener);

        restoreMe(savedInstanceState);

        CheckIfServiceIsRunning();
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putString("textStatus", textStatus.getText().toString());
        outState.putString("textIntValue", textIntValue.getText().toString());
        outState.putString("textMyID", textMyID.getText().toString());
        outState.putString("textSuccessor", textSuccessor.getText().toString());
        outState.putString("textPredecessor", textPredecessor.getText().toString());
        
        outState.putString("editMyIP", editMyIP.getText().toString());
        outState.putString("editRemoteIP", editRemoteIP.getText().toString());
        outState.putString("editMyPort", editMyPort.getText().toString());
        outState.putString("editRemotePort", editRemotePort.getText().toString());
    }
    private void restoreMe(Bundle state) {
        if (state!=null) {
            textStatus.setText(state.getString("textStatus"));
            textIntValue.setText(state.getString("textIntValue"));
            textMyID.setText(state.getString("textMyID"));
            textSuccessor.setText(state.getString("textSuccessor"));
            textPredecessor.setText(state.getString("textPredecessor"));
            
            editMyIP.setText(state.getString("editMyIP"));
            editRemoteIP.setText(state.getString("editRemoteIP"));
            editMyPort.setText(state.getString("editMyPort"));
            editRemotePort.setText(state.getString("editRemotePort"));
        } else {
        	// state==null
        	editMyIP.setText("192.168.5.152");
        	editRemoteIP.setText("192.168.5.102");
//        	editMyPort.setText("15042");
        	editMyPort.setText("10101");
            editRemotePort.setText("10101");
        }
    }

    private OnClickListener btnStartListener = new OnClickListener() {
        public void onClick(View v){
            BCAActivity.this.service = new Intent(BCAActivity.this, BCAService.class);
            startService(BCAActivity.this.service);	// context, class
            doBindService();
        }
    };
    private OnClickListener btnStopListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAActivity.this.service != null){
        		stopService(BCAActivity.this.service);        		
        	}
        	doUnbindService();
        }
    };
    
    private OnClickListener btnSocialListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), SearchActivity.class);
            	startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    private OnClickListener btnProfileListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), ProfileActivity.class);
        		startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    private OnClickListener btnFriendsListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), FriendsActivity.class);
        		startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    private OnClickListener btnBootListener = new OnClickListener() {
        public void onClick(View v){
        	editRemoteIP.setText(editMyIP.getText());
        	editRemotePort.setText(editMyPort.getText());
        }
    };
    private OnClickListener btnDhtListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), DebugActivity.class);
        		startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    void easyToast(String text){
    	Toast toast = Toast.makeText(getApplicationContext(), text, Toast.LENGTH_SHORT);
    	toast.show();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        try {
            doUnbindService();
        } catch (Throwable t) {
            Log.e("BCAActivity", "Failed to unbind from the service", t);
        }
    }
}