/**
 * Singleton
 */

package budrys.bca;

import org.jsonb.JSONException;
import org.jsonb.JSONObject;

public class Config {
	private static boolean loaded = false;
	
	public static boolean isLoaded() {
		return loaded;
	}

	public static String lastSearchText;
	public static Boolean publishProfileOnStartup = false;
	public static Boolean publishProfileNamesOnStartup = false;
	// below not saved
	public static final Long republishTimePeriodMs = (long) (30*1000);
	
	public static String exportToJson(){
		JSONObject json = new JSONObject();
		try {
			json.accumulate("lastSearchText", lastSearchText);
			json.accumulate("publishProfileOnStartup", publishProfileOnStartup);
			json.accumulate("publishProfileNamesOnStartup", publishProfileNamesOnStartup);
		} catch (JSONException e1) {
			e1.printStackTrace();
		}
		return json.toString();
	}
	
	public static boolean importFromJson(String json){
		JSONObject decode;
		try {
			decode = new JSONObject(json.toString());
			lastSearchText = decode.getString("lastSearchText");
			if (decode.has("publishProfileOnStartup")){
				publishProfileOnStartup = decode.getBoolean("publishProfileOnStartup");
			}
			if (decode.has("publishProfileNamesOnStartup")){
				publishProfileNamesOnStartup = decode.getBoolean("publishProfileNamesOnStartup");
			}
		} catch (JSONException e) {
			e.printStackTrace();
			return false;
		}
		loaded = true;
		return true;
	}
}
