package budrys.bca;

import budrys.social.ProfileModel;
import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.Toast;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.app.AlertDialog;

public class PolicyActivity extends Activity {
	private static final int SELECT_IMAGE = 0; 
	
	private Button btnPolicyBack, btnPolicySave, bntExplainAutoPublish, bntExplainAutoPublishNames;
	private CheckBox cboxAutoPublish, cboxAutoPublishNames;
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.policy);
        
        btnPolicyBack = (Button)findViewById(R.id.btnPolicyBack);
        btnPolicySave = (Button)findViewById(R.id.btnPolicySave);
        bntExplainAutoPublish = (Button)findViewById(R.id.bntExplainAutoPublish);
        bntExplainAutoPublishNames = (Button)findViewById(R.id.bntExplainAutoPublishNames);
        
        cboxAutoPublish = (CheckBox)findViewById(R.id.cboxAutoPublish);
        cboxAutoPublishNames = (CheckBox)findViewById(R.id.cboxAutoPublishNames);
        cboxAutoPublish.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				Config.publishProfileOnStartup = isChecked;
				cboxAutoPublishNames.setEnabled(isChecked);
			}
		});
        cboxAutoPublishNames.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				Config.publishProfileNamesOnStartup = isChecked;
			}
		});
        bntExplainAutoPublish.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				easyAlert("Publish profile on startup", "Allow people who have saved your publicKey to find your profile while online.\nThis option also enables periodical republishing your profile in case of data loss in the P2P network.");
			}
		});
        bntExplainAutoPublishNames.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				easyAlert("Publish by names", "Let your profile appear in search results (by name, surname or both).");
			}
		});
        
        btnPolicyBack.setOnClickListener(btnPolicyBackListener);
        btnPolicySave.setOnClickListener(btnPolicySaveListener);
        

	}
	
	public void onResume(){
		super.onResume();
		ProfileModel pm = BCAService.profileService.getProfileModel();
		cboxAutoPublish.setChecked(Config.publishProfileOnStartup);
		cboxAutoPublishNames.setEnabled(Config.publishProfileOnStartup);
	}
	
	private OnClickListener btnPolicyBackListener = new OnClickListener() {
        public void onClick(View v){
        	finish();
        }
    };
    
    private OnClickListener btnPolicySaveListener = new OnClickListener() {
        public void onClick(View v){
        	AndroidFileFunctions.setFileValue(Define.BCA_CONFIG_FILENAME, Config.exportToJson(), getBaseContext());
        }
    };
    
    
    void easyToast(String text){
    	Toast toast = Toast.makeText(getApplicationContext(), text, Toast.LENGTH_SHORT);
    	toast.show();
    }
    
    void easyAlert(String title, String text){
    	AlertDialog alertDialog = new AlertDialog.Builder(PolicyActivity.this).create();
    	alertDialog.setTitle(title);
		alertDialog.setMessage(text);
//		alertDialog.setIcon(R.drawable.tick);
		alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
		      public void onClick(DialogInterface dialog, int which) {
		      }
		});
		
		// Showing Alert Message
		alertDialog.show();
    }
}
