package budrys.bca;

import java.security.interfaces.RSAPublicKey;
import java.util.ArrayList;
import java.util.Iterator;

import budrys.bca.SearchActivity.SearchItem;
import budrys.chord.IfcCallback;
import budrys.security.Crypt;
import budrys.social.ProfileModel;
import budrys.social.ProfileService;
import budrys.social.RemoteProfile;
import budrys.social.ProfileWallEntry;
import budrys.transport.socket.TransportClient;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class ProfileActivity extends Activity {
	private Button btnProfileBack, btnProfileEdit, btnProfilePolicy, btnProfilePublish, btnViewKey, btnWallMessage, btnInvite;
	private ListView listWall;
	private TextView textProfileName, textProfileLocation, textSignatureVerified;
	private ImageView avatarView;
	private ArrayList<WallItem> entries;
	
	private ProfileModel profileModel;
	private boolean isMyProfile = false;
	private boolean isCache = false;
	
	public boolean isMyProfile() {
		return isMyProfile;
	}

	public void setMyProfile(boolean isMyProfile) {
		this.isMyProfile = isMyProfile;
	}

	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.profile);
        
        listWall = (ListView)findViewById(R.id.listWall);
//        clearPeersList();
//        addToPeersList(new WallItem("Hello!", "03-12-2012 10:30"));
//        addToPeersList(new WallItem("Sprzedam Opla !!!", "10-12-2012 18:12"));
        
        textProfileName = (TextView)findViewById(R.id.textProfileName);
        textProfileLocation = (TextView)findViewById(R.id.textProfileLocation);
        textSignatureVerified = (TextView)findViewById(R.id.textSignatureVerified);
        
        avatarView = (ImageView)findViewById(R.id.avatarView);
        
        btnProfileBack = (Button)findViewById(R.id.btnProfileBack);
        btnProfileEdit = (Button)findViewById(R.id.btnProfileEdit);
        btnProfilePolicy = (Button)findViewById(R.id.btnProfilePolicy);
        btnProfilePublish = (Button)findViewById(R.id.btnProfilePublish);
        btnViewKey = (Button)findViewById(R.id.btnViewKey);
        btnWallMessage = (Button)findViewById(R.id.btnWallMessage);
        btnInvite = (Button)findViewById(R.id.btnInvite);
        
        btnProfileBack.setOnClickListener(btnProfileBackListener);
        btnProfileEdit.setOnClickListener(btnProfileEditListener);
        btnProfilePolicy.setOnClickListener(btnProfilePolicyListener);
        btnProfilePublish.setOnClickListener(btnProfilePublishListener);      
        btnViewKey.setOnClickListener(btnViewKeyListener);  
        btnWallMessage.setOnClickListener(btnWallMessageListener);
        btnInvite.setOnClickListener(btnInviteListener);
        
        Bundle extras = getIntent().getExtras();
        if (extras != null){
        	// PREVIEW OTHER PERSON PROFILE, connect to profile
        	this.setMyProfile(false);
        	String profileUrl = extras.getString("profileUrl");
        	String profileData = extras.getString("profileData");
        	Boolean fromCache = extras.getBoolean("fromCache");
            if (profileUrl!=null){
            	btnProfileEdit.setVisibility(View.INVISIBLE);
            	btnProfilePublish.setVisibility(View.INVISIBLE);
            	final ProfileModel pm = new ProfileModel("loading ...", "wait", profileUrl);
            	fillProfileScreen(pm);
            	
            	RemoteProfile rp = new RemoteProfile(profileUrl, new TransportClient());
            	rp.getProfileData(Crypt.encodeKey(BCAService.profileService.getProfileModel().getPublicKey()), new IfcCallback() {
					public void success(String command, final String argument, Object callback) {
//						if (command.equals("getProfileDataEncrypted")){
//							final String decryptedMessage = DHTService.profileService.getProfileModel().decryptMessage(argument);
//							runOnUiThread(new Runnable() {
//			        			public void run() {
//			        				pm.importFromJson(decryptedMessage);
//									fillProfileScreen(pm);
//			        		    }
//			        		});
//						} else {
							runOnUiThread(new Runnable() {
			        			public void run() {
			        				pm.importFromJson(argument);
									fillProfileScreen(pm);
			        		    }
			        		});
//						}
					}
					public void failure(Exception e, Object reason) {
						runOnUiThread(new Runnable() {
		        			public void run() {
		        				// RETRIEVE FROM CACHE
		        				pm.importFromJson(new ProfileModel("error", "error", "error").exportPublicToJson().toString());
								fillProfileScreen(pm);
		        		    }
		        		});
					}
				});
            	rp.getAvatar(new IfcCallback() {
					public void success(String command, String argument, final Object callback) {
						runOnUiThread(new Runnable() {
		        			public void run() {
		        				easyToast("Avatar loaded: "+((byte[])callback).length);
		        		    }
		        		});
					}
					public void failure(Exception e, Object reason) {
						runOnUiThread(new Runnable() {
		        			public void run() {
		        				easyToast("Loading avatar failed");
		        		    }
		        		});
					}
				});
            } else if (profileData!=null){
            	// FILL PREVIEW WITH RECEIVED DATA, fill with precached data
            	btnProfileEdit.setVisibility(View.INVISIBLE);
            	btnProfilePublish.setVisibility(View.INVISIBLE);
            	final ProfileModel pm = new ProfileModel(profileData);
            	if (fromCache!=null){
            		pm.setFromCache(fromCache);
            	}
				fillProfileScreen(pm);
            }
        } else {
        	// PREVIEW MY PROFILE
        	this.setMyProfile(true);
        	final ProfileModel mypm = BCAService.profileService.getProfileModel();
        	fillProfileScreen(mypm);
        	
        	listWall.setOnItemLongClickListener(new OnItemLongClickListener() {
        		CharSequence[] menuItems = { "Delete", "---" };
				public boolean onItemLongClick(AdapterView<?> adapter, View view, final int longClickPos, long id) {
					Builder al = new Builder(ProfileActivity.this);
					al.setTitle("Public Message menu").setCancelable(true).setItems(menuItems,
					          new DialogInterface.OnClickListener() {
					               public void onClick(DialogInterface dialoginterface, int i) {
					                   if (i==0){
					                	   // DELETE
					                	   mypm.removeFromWall(longClickPos);
					                	   fillProfileScreen(mypm);
					                	   AndroidFileFunctions.setFileValue(Define.BCA_PROFILE_FILENAME, mypm.exportAllToJson().toString(), getBaseContext());
					                   } else {
					                	   // option = 1
					                	   // ---
					                   }
					               }
					         }
					)
					.show();
					return false;
				}

        	});
//        	registerForContextMenu(listWall);
        }
    }
	
	public void onResume(){
		super.onResume();
		if (this.isMyProfile()){
			ProfileModel pm = BCAService.profileService.getProfileModel();
			fillProfileScreen(pm);
		}
	}
	
	public void fillProfileScreen(ProfileModel pm){
		this.profileModel = pm; 
		textProfileName.setText(pm.getName()+" "+pm.getSurname());
        textProfileLocation.setText(pm.getAddress());
        if (!isMyProfile()){
        	// other person profile
        	textSignatureVerified.setText("");
        	if (pm.isSignatureVerified()){
        		textSignatureVerified.append("[Signed OK]");       
        	} else {
        		textSignatureVerified.append("[Signed WRONG!]");
        	}
        	if (pm.getPublicKey()==null){
        		btnInvite.setVisibility(View.INVISIBLE);
        		textSignatureVerified.append("[noPubKey]");
        	} else {
        		if (BCAService.friends.isFriend(Crypt.encodeKey(pm.getPublicKey()))){
        			btnInvite.setVisibility(View.INVISIBLE);
        			textSignatureVerified.append("[Friend]");
        		} else {
        			btnInvite.setVisibility(View.VISIBLE);
        			textSignatureVerified.append("[Stranger]");
        		}
        	}
        	if (pm.getRestricted()!=null){
        		textSignatureVerified.append("[Full]");
        	}
        	if (pm.isFromCache()){
        		textSignatureVerified.append("[Cache]");
        		this.isCache = true;
        	} else {
        		textSignatureVerified.append("[Online]");
        		this.isCache = false;
        	}
        	btnProfilePolicy.setVisibility(View.INVISIBLE);
        	
        } else {
        	// my profile
        	textSignatureVerified.setText("");
        	btnInvite.setVisibility(View.INVISIBLE);
        	btnProfilePolicy.setVisibility(View.VISIBLE);
        	if (pm.getAvatarPath()!=null){
        		Bitmap selectedImageBitmap = BitmapFactory.decodeFile(pm.getAvatarPath());
        		avatarView.setImageBitmap(selectedImageBitmap);
        	}
        }
        
        clearPeersList();
        Iterator<ProfileWallEntry> it = pm.getWall().iterator();
        while (it.hasNext()){
        	ProfileWallEntry pwe = it.next();
        	addToPeersList(new WallItem(pwe.getMessage(), pwe.getDate(), pwe.getName()));
        }
	}
	
	private OnClickListener btnProfileBackListener = new OnClickListener() {
        public void onClick(View v){
        	finish();
        }
    };
	
	private OnClickListener btnProfileEditListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), EditProfileActivity.class);
        		startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    
    private OnClickListener btnProfilePolicyListener = new OnClickListener() {
        public void onClick(View v){
        	if (BCAService.isRunning()){
        		Intent i = new Intent(getApplicationContext(), PolicyActivity.class);
        		startActivity(i);
        	} else {
        		easyToast("Start the service first");
        	}
        }
    };
    
    private OnClickListener btnProfilePublishListener = new OnClickListener() {
        public void onClick(View v){
        	ProfileModel pm = BCAService.profileService.getProfileModel();
        	String myDHTEntry = BCAService.chord.getMyIp() + ":" + BCAService.profileService.getMyPort().toString();
        	if (pm.getPublicKey()!=null){
        		BCAService.chord.dhtStore(Crypt.encodeKey(pm.getPublicKey()), myDHTEntry, new IfcCallback() {
    				public void success(String command, String argument, Object callback) {					
    				}
    				public void failure(Exception e, Object reason) {
    				}
    			});
        	}
        	BCAService.chord.dhtStore(pm.getName(), myDHTEntry, new IfcCallback() {
				public void success(String command, String argument, Object callback) {					
				}
				public void failure(Exception e, Object reason) {
				}
			});
        	BCAService.chord.dhtStore(pm.getSurname(), myDHTEntry, new IfcCallback() {
				public void success(String command, String argument, Object callback) {					
				}
				public void failure(Exception e, Object reason) {
				}
			});
        	BCAService.chord.dhtStore(pm.getName()+" "+pm.getSurname(), myDHTEntry, new IfcCallback() {
				public void success(String command, String argument, Object callback) {					
				}
				public void failure(Exception e, Object reason) {
				}
			});
        	BCAService.chord.dhtStore(pm.getSurname()+" "+pm.getName(), myDHTEntry, new IfcCallback() {
				public void success(String command, String argument, Object callback) {					
				}
				public void failure(Exception e, Object reason) {
				}
			});
        }
    };
    
    private OnClickListener btnViewKeyListener = new OnClickListener() {
        public void onClick(View v){
        	if (profileModel!=null){
        		if (profileModel.getPublicKey() != null){
        			easyToast(" -----BEGIN RSA PUBLIC KEY-----\n"+Crypt.encodeKey(profileModel.getPublicKey())+"\n-----END RSA PUBLIC KEY-----");        			
        		} else {
        			easyToast("Public Key is null");
        		}
        	} else {
        		easyToast("Profile not defined");
        	}
        }
    };
    
    private OnClickListener btnWallMessageListener = new OnClickListener() {
        public void onClick(View v){
        	if (isMyProfile){
        		// post on my wall
        		if (profileModel!=null){
        			final AlertDialog.Builder alert = new AlertDialog.Builder(ProfileActivity.this);
        		    final EditText input = new EditText(ProfileActivity.this);
        		    alert.setView(input);
        		    alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
        		        public void onClick(DialogInterface dialog, int whichButton) {
        		            String value = input.getText().toString().trim();
//        		            Toast.makeText(getApplicationContext(), value, Toast.LENGTH_SHORT).show();
        		            if (value.length() > 0){
        		            	profileModel.getWall().add( new ProfileWallEntry(value, Define.getNowTimeString(), BCAService.profileService.getProfileModel().getName()+" "+BCAService.profileService.getProfileModel().getSurname()) );      
        		            	AndroidFileFunctions.setFileValue(Define.BCA_PROFILE_FILENAME, profileModel.exportAllToJson().toString(), getBaseContext());
        	        			fillProfileScreen(profileModel);
        		            }
        		        }
        		    });
        		    alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
        		        public void onClick(DialogInterface dialog, int whichButton) {
        		            dialog.cancel();
        		        }
        		    });
        		    alert.show();
        		} else {
        			easyToast("profile is null");
        		}
        	} else {
        		// post on someone's wall
        		if (isCache){
        			easyToast("Cannot post on someone's wall if is offline");	
        		} else {
        			final AlertDialog.Builder alert = new AlertDialog.Builder(ProfileActivity.this);
        		    final EditText input = new EditText(ProfileActivity.this);
        		    alert.setView(input);
        		    alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
        		        public void onClick(DialogInterface dialog, int whichButton) {
        		            final String value = input.getText().toString().trim();
        		            if (value.length() > 0){
        		            	final ProfileWallEntry postPwe = new ProfileWallEntry(value, Define.getNowTimeString(), BCAService.profileService.getProfileModel().getName()+" "+BCAService.profileService.getProfileModel().getSurname());
        		            	// find profile host up to date by its publicKey
        		            	BCAService.chord.dhtGet(Crypt.encodeKey(ProfileActivity.this.profileModel.getPublicKey()), new IfcCallback() {
        		    				public void success(final String command, final String profileUrl, Object callback) {
        		    					runOnUiThread(new Runnable() {
        		    	        			public void run() {
        		    	        				if (RemoteProfile.isValidUrl(profileUrl)){
        		    	        					RemoteProfile rp = new RemoteProfile(profileUrl, new TransportClient());
        		    		        				rp.publishWallMessage(postPwe.exportToJson().toString(), new IfcCallback() {
														public void success(String command, String argument, Object callback) {
															runOnUiThread(new Runnable() {
					        		    	        			public void run() {
					        		    	        				easyToast("Public message published successfully.");
					        		    	        		    }
					        		    	        		});
														}
														public void failure(Exception e, Object reason) {
															runOnUiThread(new Runnable() {
					        		    	        			public void run() {
					        		    	        				easyToast("Posting public message has failed.");
					        		    	        		    }
					        		    	        		});
														}
													});
        		    	        				} else {
        		    	        					// url not valid
        		    	        					runOnUiThread(new Runnable() {
        	        		    	        			public void run() {
        	        		    	        				easyToast("Host not found (invalid url). Try again another time when host is online");
        	        		    	        		    }
        	        		    	        		});
        		    	        				}
        		    	        		    }
        		    	        		});
        		    										
        		    				}
        		    				public void failure(Exception e, final Object reason) {
        		    					runOnUiThread(new Runnable() {
        		    	        			public void run() {
        		    	        				easyToast("Host not found. Try again another time when host is online");
        		    	        		    }
        		    	        		});
        		    				}
        		    			});
//        		            	RemoteProfile
//        		            	publishWallMessage
        		            }
        		        }
        		    });
        		    alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
        		        public void onClick(DialogInterface dialog, int whichButton) {
        		            dialog.cancel();
        		        }
        		    });
        		    alert.show();
        		}
        	}
        }
    };
    
    private OnClickListener btnInviteListener = new OnClickListener() {
        public void onClick(View v){
        	if (isMyProfile){
        		// invite yourself
        		easyToast("NOT AVAILABLE HERE, report bug!");
        	} else {
        		// invite someone
        		if (profileModel!=null){
        			RSAPublicKey pubKey = ProfileActivity.this.profileModel.getPublicKey();
        			if (pubKey!=null){
        				BCAService.friends.addFriend(Crypt.encodeKey(pubKey), ProfileActivity.this.profileModel);
        				AndroidFileFunctions.setFileValue(Define.BCA_FRIENDS_FILENAME, BCAService.friends.exportAllToJson().toString(), getBaseContext());
            			fillProfileScreen(profileModel);
        				easyToast("Successfully saved in your friends list");
        			} else {
        				easyToast("Cannot invite, publicKey is null");
        			}
        		} else {
        			easyToast("profile is null");
        		}
        	}
        }
    };
    
    void easyToast(String text){
    	Toast toast = Toast.makeText(getApplicationContext(), text, Toast.LENGTH_SHORT);
    	toast.show();
    }
	
	private void updatePeersList(){
		if (entries == null){
			entries = new ArrayList<WallItem>();
		}
		WallAdapter wallAdapter = new WallAdapter(ProfileActivity.this, R.layout.dht_peerslist,entries);
		wallAdapter.setNotifyOnChange(true);
    	listWall.setAdapter(wallAdapter);
    	listWall.setTextFilterEnabled(true);
	}
	
	private void addToPeersList(WallItem str){
		if (entries == null){
			entries = new ArrayList<WallItem>();
		}
    	entries.add(0, str);
    	updatePeersList();
	}
	
	private void clearPeersList(){
		entries = new ArrayList<WallItem>();
    	updatePeersList();
	}
	
	public class WallItem {
    	private String top;
    	private String bottom;
    	private String name;

		public WallItem(String nTop, String nBottom, String nname){
    		this.setTop(nTop);
    		this.setBottom(nBottom);
    		this.setName(nname);
    	}

		public String getTop() {
			return top;
		}

		private void setTop(String top) {
			this.top = top;
		}

		public String getBottom() {
			return bottom;
		}

		private void setBottom(String bottom) {
			this.bottom = bottom;
		}
		
    	public String getName() {
			return name;
		}

		private void setName(String name) {
			this.name = name;
		}
    }
    
    private class WallAdapter extends ArrayAdapter<WallItem> {

        private ArrayList<WallItem> items;

        public WallAdapter(Context context, int textViewResourceId, ArrayList<WallItem> items) {
                super(context, textViewResourceId, items);
                this.items = items;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
                View v = convertView;
                if (v == null) {
                    LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
                    v = vi.inflate(R.layout.profile_walllist, null);
                }
                WallItem o = items.get(position);
                if (o != null) {
                        TextView tt = (TextView) v.findViewById(R.id.toptext);
                        TextView bt = (TextView) v.findViewById(R.id.bottomtext);
                        TextView nt = (TextView) v.findViewById(R.id.nametext);
                        if (tt != null) {
                              tt.setText(o.getTop());                            
                        }
                        if(bt != null){
                              bt.setText(o.getBottom());
                        }
                        if(nt != null){
                        	nt.setText(o.getName());
                      }
                }
                return v;
        }
    }
    
}
