package budrys.chord;

import org.jsonb.JSONException;
import org.jsonb.JSONObject;

public class PeerDHT extends Peer {

	public PeerDHT(Long id, IfcTransportClient tc) {
		super(id, tc);
		// TODO Auto-generated constructor stub
	}
	
	public void dhtRedistribute(ID shareWith, final IfcCallback callback){
		this.tc.request(peerID.getIP(), peerID.getPort(), "dhtRedistribute", shareWith.getID().toString(), new IfcCallback() {
			public void success(String command, String argument, Object cb) {
				if (command.equals("dhtRedistribute")){
					callback.success(command, argument, null);
				} else {
					// response comes from other method, programmer error or hacking attempt
					callback.failure(new ChordException("Peer wrong response"), null);
				}
			}
			public void failure(Exception e, Object reason) {
				e.printStackTrace();
				callback.failure(e, reason);
			}
		});
	}
	
	public void dhtStore(String key, String value, final IfcCallback callback){
		// TODO json
		JSONObject json = new JSONObject();
		try {
			json.accumulate("key", key);
			json.accumulate("value", value);
		} catch (JSONException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			//callback.failure(e1, null);
		}
		String encodedKeyValuePair = json.toString();
		this.tc.request(peerID.getIP(), peerID.getPort(), "dhtStore", encodedKeyValuePair, new IfcCallback() {
			public void success(String command, String argument, Object cb) {
				if (command.equals("dhtStore")){
					callback.success(command, argument, null);
				} else {
					// response comes from other method, programmer error or hacking attempt
					callback.failure(new ChordException("Peer wrong response"), null);
				}
			}
			public void failure(Exception e, Object reason) {
				e.printStackTrace();
				callback.failure(e, reason);
			}
		});
	}
	
	public void dhtGet(String key, final IfcCallback callback){
		this.tc.request(peerID.getIP(), peerID.getPort(), "dhtGet", key, new IfcCallback() {
			public void success(String command, String argument, Object cb) {
				if (command.equals("dhtGet")){
					Log.i("peer.dhtGet: "+argument);
					callback.success(command, argument, null);
				} else {
					// response comes from other method, programmer error or hacking attempt
					callback.failure(new ChordException("Peer wrong response"), null);
				}
			}
			public void failure(Exception e, Object reason) {
				e.printStackTrace();
				callback.failure(e, reason);
			}
		});
	}
	
	public void dhtDelete(String key, final IfcCallback callback){
		this.tc.request(peerID.getIP(), peerID.getPort(), "dhtDelete", key, new IfcCallback() {
			public void success(String command, String argument, Object cb) {
				if (command.equals("dhtDelete")){
					callback.success(command, argument, null);
				} else {
					// response comes from other method, programmer error or hacking attempt
					callback.failure(new ChordException("Peer wrong response"), null);
				}
			}
			public void failure(Exception e, Object reason) {
				e.printStackTrace();
				callback.failure(e, reason);
			}
		});
	}
	
}
