package budrys.social;

import org.jsonb.JSONException;
import org.jsonb.JSONObject;

import budrys.security.Crypt;

public class ProfileWallEntry {
	private String message;
	private String date;
	private String name;
	private String signature;
	private String pubKey;
	private String receiverPubKey;

	public ProfileWallEntry(String message, String date, String name){
		this.setMessage(message);
		this.setDate(date);
		this.setName(name);
	}
	
	public ProfileWallEntry(String message, String date, String name, String signature, String pubKey, String receiverPubKey){
		this.setMessage(message);
		this.setDate(date);
		this.setName(name);
		this.setSignature(signature);
		this.setPubKey(pubKey);
		this.setReceiverPubKey(receiverPubKey);
	}
	
	public ProfileWallEntry(String json){
		this.importFromJson(json);
	}
	
	public boolean importFromJson(String json){
		JSONObject decode;
		try {
			decode = new JSONObject(json.toString());
			if (decode.has("message")){
				message = decode.getString("message");
			}
			if (decode.has("date")){
				date = decode.getString("date");
			}
			if (decode.has("name")){
				name = decode.getString("name");
			}
			if (decode.has("pubKey")){
				pubKey = decode.getString("pubKey");
				if (decode.has("signature")){
					signature = decode.getString("signature");
					if (decode.has("receiverPubKey")){
						receiverPubKey = decode.getString("receiverPubKey");
					}
				}
			}
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public JSONObject exportToJson(){
		JSONObject json = new JSONObject();
		try {
			json.accumulate("message", message);
			json.accumulate("date", date);
			json.accumulate("name", name);
			json.accumulate("signature", signature);
			json.accumulate("pubKey", pubKey);
			json.accumulate("receiverPubKey", receiverPubKey);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return json;
	}
	
	public String getMessage() {
		return message;
	}
	private void setMessage(String message) {
		this.message = message;
	}
	public String getDate() {
		return date;
	}
	private void setDate(String date) {
		this.date = date;
	}
	public String getName() {
		if (this.name==null){
			return "";
		}
		return name;
	}
	private void setName(String name) {
		this.name = name;
	}
	public String getSignature() {
		return signature;
	}
	private void setSignature(String signature) {
		this.signature = signature;
	}
	public String getPubKey() {
		return pubKey;
	}
	private void setPubKey(String pubKey) {
		this.pubKey = pubKey;
	}
	public String getReceiverPubKey() {
		return receiverPubKey;
	}

	private void setReceiverPubKey(String receiverPubKey) {
		this.receiverPubKey = receiverPubKey;
	}

	
	public String toString(){
		super.toString();
		return this.exportToJson().toString();
	}
}
