package budrys.social;

import budrys.chord.IfcCallback;
import budrys.chord.IfcTransportClient;

public class RemoteProfile {
	protected IfcTransportClient tc;
	protected String address;
	protected Short port;
	
	public static boolean isValidUrl(String url){
		if (url==null){
			return false;
		}
		if (url.indexOf(':') > -1){
			return true;
		}
		return false;
	}
	
	public RemoteProfile(String address, Short port, IfcTransportClient tc){
		this.address = address;
		this.port = port;
		this.tc = (IfcTransportClient) tc.cclone();
	}
	
	public RemoteProfile(String addressAndPort, IfcTransportClient tc){
		String[] addrParts = addressAndPort.split(":");
		this.address = addrParts[0];
		this.port = Short.valueOf(addrParts[1]);
		this.tc = (IfcTransportClient) tc.cclone();
	}
	
	// callback arg = String = json encoded data
	/**
	 * Get public profile data 
	 * @param callback
	 */
	public void getProfileData(IfcCallback callback){
		getProfileData(null, callback);
	}
	/**
	 * Get profile data according to passed publicKey privilleges
	 * @param publicKey
	 * @param callback
	 */
	public void getProfileData(String publicKey, IfcCallback callback){
		tc.request(address, port, "getProfileData", publicKey, callback);
	}
	
	public void publishWallMessage(String profileWallEntryJSONEncoded, IfcCallback callback){
		tc.request(address, port, "publishWallMessage", profileWallEntryJSONEncoded, callback);
	}
	
	public void getAvatar(IfcCallback callback){
		tc.request(address, port, "getAvatar", "", callback, true);
	}
}
